<template>
	<div class="print_grid_style" >
		<el-main>
			<TitlePrint :text="`Programación de la ${dateString}`"/>
			<div class="flex-content just-center">
				<!-- lateral schedule -->
				<div>
					<div class="grid-schedule-title box_style_border_left width-50" ref="scrollSchedule">
						<div style="height: 31px"></div>
					</div>

					<div class="box_style box_style_border_left">
						<div style="grid-row:1/4" class="grid-schedule resize o-hidden">
							<p class="font-size-16"> 05:16 </p>
						</div>
						<div class="grid-schedule resize flex-content justify-content-center font-size-12" 
						v-for="(time, index) in timeForDay" 
						:key="index" :style="`grid-area: ${(6*  index) +4} / 1/ span 6 / 2`">
							<p class="font-size-16">{{ time }}</p>
						</div>
						<div class="grid-schedule resize o-hidden border-none" style="grid-row:286/289">
							<p class="font-size-16"> 05:00 </p>
				 		</div>
					</div>

					<div class="grid-schedule-title box_style_border_left">
						<div style="height: 31px">-</div>
					</div>
				</div>
				<!-- content schedule -->
				<div>
					<gridDays :days="generateDays()" :sizeLetters="'font-size-18 d-flex flex-content justify-content-center'" :space="'pl-5'"/>
					<!--  -->
					<div class="grid-programs" ref="contenedor" >
						<div v-for="(program, index) in orderByProgram" :key="index" :ref="`cell-${index}`" :class="[styleByDurationProgram(program.programPrincipal), sizeProgram(program.programByDay), getResize(index, program)]">
							
							<!-- <div class="text-center">
								<div class="work-break box_title"  style="display: inline-block" :class="[durationProgramResize(program.programByDay)]">
									<div class="text-blue-color principalTitle width_auto text-center" :class="[styleTitlePrincipal(program.programByDay)]">
										<span class="width_auto text-center">{{ program.programPrincipal.programTitle }}</span>
										<p style="color: #4cb253 !important;" class="pl-10" v-html="priceReturn(program.programByDay)"></p>
									</div>
								</div>
							</div> -->
							<div v-if="program.programByDay.length == 1 && program.programPrincipal.typeOfContent !== 'Largometrajes' && program.programPrincipal.typeOfContent !== 'LARGOMETRAJES'" class="width_auto text-center">
								<div class="work-break box_title"  style="display: inline-block" :class="[durationProgramResize(program.programByDay)]">
									<div class="text-blue-color principalTitle width_auto text-center" :class="[styleTitlePrincipal(program.programByDay)]" v-if="program.programPrincipal.typeOfContent !== 'Largometrajes' &&  program.programPrincipal.typeOfContent !== 'LARGOMETRAJES'">
										<span class="width_auto text-center">{{ program.programPrincipal.programTitle }}</span>
										<p style="color: #4cb253 !important; display: inline-block" class="pl-10" v-html="priceReturn(program.programByDay)"></p>
									</div>
								</div>
							</div>
							<div v-else>
								<div class="work-break box_title" :class="[durationProgramResize(program.programByDay)]">
									<div class="text-blue-color principalTitle text-center"  v-if="program.programPrincipal.typeOfContent !== 'Largometrajes' &&  program.programPrincipal.typeOfContent !== 'LARGOMETRAJES'" :class="[styleTitlePrincipal(program.programByDay)]">
										<p class="text-cener width_auto">{{ program.programPrincipal.programTitle }}</p></div>
									<!-- Titulo del programa para largometrajes -->
									<div v-else>
										<p class="text-orange principalTitle work-break" :class="durationProgramTitleLargometraje(program.programPrincipal)">"{{ program.programPrincipal.programTitle }}"<p>
										<p class="principalTitle text-blue-color work-break style_text_film"  :class="durationProgram(program)">{{ program.programPrincipal.materialTitle }}</p>
									</div>
								</div>
								<div class="boxAllDaysContent" :class="[calculateTime(program.programPrincipal) > '00:15:00' ? '' : 'mt-2']">
									<!-- tengo mas de un dia -->
									<div class="boxByDay" v-for="(day, index) in program.programByDay" :key="index" :style="`grid-column: ${index+1} / span 1; backgroundColor: ${day.bgColorByProgram}`" >
										<div class="boxByChapter flex-content justify-content-space p-i-0" v-html="priceForCap(day.chapters, program.programPrincipal.programTitle)" style="color: #4cb253 !important; font-size:14px"></div>
									</div>
								</div>
							</div>
							<!-- NOTA GENERAL -->
							<div v-if="program.programPrincipal.generalNoteBoss && program.programPrincipal.generalNoteBoss !== '' && calculateTime(program.programPrincipal) > '00:45:00'" class="flex-content justify-content-center general-note-style work-break text-center line-height-11" :class="[sizeTextGeneralNote(program)]" v-html="program.programPrincipal.generalNoteBoss"></div>
							
							<div class="boxAllDays p-absolute box_content" :class="[durationProgramResize(program.programByDay)]">
								<!-- tengo mas de un dia -->
								<div class="boxByDay" v-for="(day, index) in program.programByDay" :key="index" :style="`grid-column: ${index+1} / span 1; backgroundColor: ${day.bgColorByProgram}`" >
									<div class="contentBoxByChapter p-absolute">
										<div v-if="day.nota && day.nota !== ''" class="note note-style-middle line-height-9 " v-html="day.nota"></div>
										<div v-if="day.noteDay && day.noteDay !== ''" class="note note-style-middle line-height-9 " v-html="day.noteDay"></div>
									</div>
								</div>
							</div>

						</div>
					</div>
					<gridDays :days="generateDays()" :sizeLetters="'font-size-18 d-flex flex-content justify-content-center'" :space="'pl-5'"/>
				</div>
				<div>
					<div>
						<div class="grid-schedule-title box_style_border_rigth width-50" ref="scrollSchedule">
							<div style="height: 31px"></div>
						</div>


						<div class="box_style box_style_border_rigth">
							<div class="grid-schedule resize o-hidden" style="grid-row:1/4"> 
								<p class="font-size-16"> 05:16 </p>
							</div>

							<div class="grid-schedule resize flex-content justify-content-center font-size-12" 
							v-for="(time, index) in timeForDay" 
							:key="index" :style="`grid-area: ${(6*  index) +4} / 1/ span 6 / 2`">
								<p class="font-size-16">{{ time }}</p>
							</div>
							<div class="grid-schedule resize o-hidden border-none" style="grid-row:286/289">
								<p class="font-size-16"> 05:00 </p>
							</div>
						</div>

						<div class="grid-schedule-title box_style_border_rigth">
							<div style="height: 31px"></div>
						</div>
					</div>
				</div>
			</div>
			<div class="flex-content just-center">
				<div style="display: grid; grid-template-columns: repeat(7, 170px); align-items: center; margin: 2rem 60px 2rem 60px" ref="scroll">
					<div  v-for="(day, index) in priceByDay" :key="index" class="flex-content justify-content-center font-size-18">
						<span class="textCollapse" style="color: #4cb253 !important; font-weight: 700"> USD {{getFormat(day.number)}} </span> 
					</div>
				</div>
			</div>
			<div style="font-size: 16px; font-weight: 700" class="flex-content justify_end mx-105"> 
				<span style="color: #00009 !important;">  IMPORTE SEMANAL </span>  <span style="margin-left: 10px; color: #4cb253 !important"> USD  {{ getFormat(totalAmount) }} </span> </div>  
		</el-main>
	</div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import ModalContentComponent from './components/ModalContent'
import gridDays from '@/components/grid/gridDays'
import Title from '@/components/Title.vue'
import { sizeLetttersAboutProgram, calculateSchedule, sizeLetttersAboutProgramCompare } from '@/utils/calculateSizeLetters.js'
import { getFirstDay, convertNumberFormatUsd } from '@/utils/calculateTime.js'
import { addingZerosToTheDay, convertFormatDayForCrusses, convertHourDate } from '@/utils/calculateTimePrograms.js'
import { modelProgramByDay } from '@/utils/util.js'
import { HTTP } from '@/main.js'
import TitlePrint from '@/components/grid/titlePrint'
import gridSchedule from '@/components/grid/gridSchedule'

export default {
	components: {
    'app-title': Title,
		ReturnButton,
		ModalContentComponent,
		gridDays,
		TitlePrint,
		gridSchedule
	},
	data () {
		return {
			dataTable: '',
			dateSearch: '',
			firstDayOfWeek: '',
			firstDay: JSON.parse(sessionStorage.getItem('firstDay')) ,
			secondDay: JSON.parse(sessionStorage.getItem('secondDay')) ,
			thirdDay: JSON.parse(sessionStorage.getItem('thirdDay')) ,
			fourthDay: JSON.parse(sessionStorage.getItem('fourthDay')) ,
			fifthDay: JSON.parse(sessionStorage.getItem('fifthDay')) ,
			sixthDay: JSON.parse(sessionStorage.getItem('sixthDay')) ,
			lastDay: JSON.parse(sessionStorage.getItem('lastDay')) ,
			month: '',
			month2: '',
			year: '',
			year2: '',
			startDate: '',
			endDate: '',
			orderByProgram: [],
			idOfPrograms: [],
			hour: 5,
			minute: 0,
			contentHtml: '',
			dateString: JSON.parse(sessionStorage.getItem('dateString')),
			modalInfo: false,
			programSelected: {},
			transmission: [],
			allDiasByProgram: [],
			timeForDay: [],
			isSelectColor: false,
			checkAllDays: [],
			changeStatus: '',
			clasificationColor: '',
			notShowSchedule: false,
			dataAllWeek: [],
			allProgramsWithGrid: JSON.parse(sessionStorage.getItem('allProgramsWithGrid')),
			chanelTransmission: this.$localStorage.get('channelTransmition'),
      		printView: this.$route.params.grid,
            priceByDay : [
						{
							name: 'Lunes',
				number: 0,
				currencySymbol: ''
						},
						{
							name: 'Martes',
				number: 0,
				currencySymbol: ''
						},
						{
							name: 'Miercoles',
				number: 0,
				currencySymbol: ''
						},
						{
							name: 'Jueves',
				number: 0,
				currencySymbol: ''
						},
						{
							name: 'Viernes',
				number: 0,
				currencySymbol: ''
						},
						{
							name: 'Sábado',
				number: 0,
				currencySymbol: ''
						},
						{
							name: 'Domingo',
				number: 0,
				currencySymbol: ''
						}
			],
      		dias : ['Lunes', 'Martes', 'Miércoles', 'Jueves', 'Viernes', 'Sábado', 'Domingo']
		}
	},
	computed: {
		totalAmount () {
		let total = 0
		this.priceByDay.map((el, i, arr) => {
			total += parseFloat(Number(el.number))
		})
		return total
		}
	},
	mounted(){
		let alturas = []
		for(let i=1; i<=288; i++){alturas.push['6px']};
		let templateRows = alturas.join(' ');
		const items = document.querySelectorAll('.grid-schedule');
		const boxes = document.querySelectorAll('.box_style');
		const grids = document.querySelectorAll('.grid-programs')
		boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
		grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)		

		window.addEventListener('mouseup',()=>{
			items.forEach(item=>{
				let style = item.getAttribute('style').split(';');
				item.setAttribute('style',style[0])
			})
		})

		var ro = new ResizeObserver( entries => {
			for (let entry of entries) {
				const cr = entry.contentRect;
				const hg = parseInt(cr.height);
				let maxIndex = 6;
				let gridLine = parseInt(entry.target.style.gridRow);
				let divBorder = gridLine==286? 0:3;				
				maxIndex = gridLine==1 || gridLine==286 ? 3:6
				let calculateHeigth = Math.floor((Math.floor(hg)+divBorder)/maxIndex)
				for(let j=gridLine -1; j<= gridLine+maxIndex-2; j++){
					alturas[j]= calculateHeigth+'px';
				}
				templateRows = alturas.join(' ');
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			}
		});

		items.forEach(item=>ro.observe(item))
	},
	methods: {
		priceForCap(program, title) {
			let counter = []
			program.map((e) => {
				const {currencySymbolChap, priceByPass} = e
				let type = typeof(priceByPass) == "number" ? String(priceByPass) : priceByPass
				if(type && type !== '') {
					counter.push(`<span>USD ${this.getFormat(priceByPass)}</span>`)
				}
			})
			return counter.join(', ')
		},
		priceReturn(program) {
			let chapter = program.map((e) => {
				let counter = []
				e.chapters.forEach((e) => {
					let type = typeof(e.priceByPass) == "number" ? String(e.priceByPass) : e.priceByPass
					if(type && type !== '') {
						counter.push(e.priceByPass)
					}
				})
				return counter
			})
			let chapterTransform = [].concat.apply([], chapter)
			// console.log(program, 'program')
			// console.log(chapterTransform, 'chapterTransform')
			return chapterTransform[0] ?  `USD ${this.getFormat(chapterTransform[0])}` : 'USD 0.00'
			// return 'a'
		},
		sizeProgram(program) {
			const {programTitle} = program[0]
			const data = this.calculateTime(program[0])
			if(data < '00:15:00') {
				return 'grid-programs_small_show_big'
			} else {
				return 'grid-byProgram'
			}
		},
		generateDays() {
			const days = [
				{
					name: 'Lunes',
					number: addingZerosToTheDay(this.firstDay),
				},
				{
					name: 'Martes',
					number: addingZerosToTheDay(this.secondDay),
				},
				{
					name: 'Miercoles',
					number: addingZerosToTheDay(this.thirdDay),
				},
				{
					name: 'Jueves',
					number: addingZerosToTheDay(this.fourthDay),
				},
				{
					name: 'Viernes',
					number: addingZerosToTheDay(this.fifthDay),
				},
				{
					name: 'Sábado',
					number: addingZerosToTheDay(this.sixthDay),
				},
				{
					name: 'Domingo',
					number: addingZerosToTheDay(this.lastDay),
				}
			]
			return days
		},
    	getFormat (valor) {
			if ( valor != 'Cortesía' ) {
				return convertNumberFormatUsd(Number(valor))
			}
			else {
				return valor
			}
    	},
		getPriceForDay (allPrograms) {		
			this.dias.map((dia, y) => {
				let mount = 0
				let simbol = ''

				let filterByDay = allPrograms.filter(function(item) {
				return item.completeDate.includes(dia)
				})
				if (filterByDay.length > 0 ) {
				
				// console.log(filterByDay, 'filterByDay')
				
				filterByDay.map( (el, i, arr ) => {
					el.chapters.map((chap) => {
					// console.log(chap.priceByPass, 'chap.priceByPass')
					if ( chap.priceByPass ) {
						mount += parseFloat(chap.priceByPass)
					}
					})
				})
				let hola = this.priceByDay[y].number
				this.priceByDay[y].number = mount.toFixed(2)
				this.priceByDay[y].currencySymbol = 'USD'
				}
				else { 
				this.priceByDay[y].number = ''
				}
				// console.log(filterByDay, 'filterByDay')
			})
			// console.log(this.priceByDay, 'this.priceByDay')
		},
		openModal(program) {   
			this.programSelected = program.programPrincipal
			this.allDiasByProgram = program.programByDay
			this.modalInfo = true
		},
		closeModal() {
			this.modalInfo = false
		},
		addClassToProgramTitle (program) {
			let hasChapters = false
			if(!(program.programByDay.length > 1)){
				if(!(program.programByDay[0].material.numChapters.length > 0)){
					hasChapters = true
				}
			}
			return hasChapters
		},
		handleScroll (event) {
		  let sticky = this.$refs.scroll
			if (window.pageYOffset >= 300) {
				sticky.classList.add("sticky")
			} else {
				sticky.classList.remove("sticky");
			}

			let stickySchedule = this.$refs.scrollSchedule
			if (window.pageYOffset >= 300) {
				stickySchedule.classList.add("sticky")
			} else {
				stickySchedule.classList.remove("sticky");
			}

			let stickyScheduleRight = this.$refs.scrollScheduleRight
			if (window.pageYOffset >= 300) {
				stickyScheduleRight.classList.add("sticky")
			} else {
				stickyScheduleRight.classList.remove("sticky");
			}
    	},
		returnPage () {
      		this.$router.push({ name: 'views'})
		},
		getWeek (week) {
			let res = this.allProgramsWithGrid
			// console.log(res, 'res')
			this.orderByProgram = []
			this.idOfPrograms = []
			// const responseText = 'Week not found'
			const responseText = "Week not found weekDate"
			// const {weekDate} = this.allProgramsWithGrid
			if(res !== responseText) {

        	this.getPriceForDay(res.preliminaryPrograms)

				// this.dataAllWeek = weekDate
				const {preliminaryPrograms} = res

				// FILTRO POR CANAL DE TRANSMISION
				let isTrue = false
				let programsByChannel = []
				preliminaryPrograms.map((program)=>{
					if(program.refProgram.checkedChanels.length > 0){
						program.refProgram.checkedChanels.map((channel)=> {
							if(channel.toLowerCase() == this.chanelTransmission.toLowerCase()){
								programsByChannel.push(program)
							}
						})
					} else {
						programsByChannel.push(program)
					}
				})
				// RECORRE LA DATA QUE TRAE LA RESPUESTA
				programsByChannel.map((program)=>{
					const {refProgram: {_id}} = program

					const object = {
						programPrincipal: this.modelPrincipalProgram(program),
						programByDay: [modelProgramByDay(program)]
					}

					if(this.idOfPrograms.includes(_id) == false){
						// INSERTA LOS PROGRAMAS SI SUS ID'S NO HAN SIDO INSERTADOS ANTERIORMENTE
						this.idOfPrograms.push(_id)
						this.orderByProgram.push(object)
					} else {
						const {refProgram: {codeDays}} = program

						let arrSamePrograms = []
						this.orderByProgram.map((program, index)=>{
							if(program.programPrincipal._id == _id){
								arrSamePrograms.push(index)
							}
						})
						
						let daySelected = this.getDayCode(program.completeDate)
						
						let addToProgram = false
						//RECORRE EL ARRAY DE PROGRAMAS QUE SE HAN CREADO PERO QUE PERTENECEN AL MISMO PROGRAMA
						for(let i=0; i<arrSamePrograms.length; i++){
							let programSelected = this.orderByProgram[arrSamePrograms[i]]
							let daysSaved = []
							//GUARDA EN UN ARRAY LOS DIAS QUE SE HAN GUARDADO EN EL PROGRAMA
							programSelected.programByDay.map((programDay)=>{
								const day = programDay.completeDate
								const daySaved = this.getDayCode(day)
								daysSaved.push(daySaved)
							})
							
							//RECORRE LOS DIAS DEL PROGRAMA 
							codeDays.map((day, index)=>{
								//VERIFICA EL DIA SELECCIONADO
								if(day == daySelected){
									//SI ES DOMINGO SE CAMBIA A 8 PORQUE CON EL 1 NO VALIDA CORRECTAMENTE
									daySelected = (daySelected == 1)? 8: daySelected
									//VALIDA SI EL DIA SELECCIONADO ES CORRELATIVO EN EL ARRAY DE DIAS DEL PROGRAMA
									if(codeDays.includes(daySelected-1) || codeDays.includes(daySelected+1)){
										//RECORRE LOS DIAS DEL PROGRAMA YA INGRESADOS
										daysSaved.map((savedDay)=>{
											//VERIFICA QUE EL DIA SELECCIONADO SEA CORRELATIVO A LOS DIAS QUE YA ESTAN INGRESADOS
											if(savedDay == (daySelected-1) || savedDay ==  (daySelected+1)){
												// VERIFICA QUE LOS DIAS CONTENGAN EL MISMO HORARIO
												const indexArrProgram = programSelected.programByDay.length -1
												const lastProgram = programSelected.programByDay[indexArrProgram]
												const programByDay = modelProgramByDay(program)
												
												let lastProgramTimeStart = this.convertToMinutes(lastProgram.scheduleStartHour, lastProgram.scheduleStartMin)
												let lastProgramTimeEnd = this.convertToMinutes(lastProgram.scheduleEndHour, lastProgram.scheduleEndMin)

												let programSelectedTimeStart = this.convertToMinutes(programByDay.scheduleStartHour, programByDay.scheduleStartMin)
												let programSelectedTimeEnd = this.convertToMinutes(programByDay.scheduleEndHour, programByDay.scheduleEndMin)

												if((lastProgramTimeStart == programSelectedTimeStart) && (lastProgramTimeEnd == programSelectedTimeEnd)){
													addToProgram = true
													programSelected.programByDay.push(modelProgramByDay(program))
												} else {
													addToProgram = false
												}
												
											}
										})
									}
								}
							})
						}

						//AGREGA COMO NUEVO PROGRAMA SI NO ES UN DIA CORRELATIVO
						if(addToProgram == false){
							this.orderByProgram.push(object)
						}

					}
				})
			}
				
			this.orderByProgram = this.sortByHour(this.orderByProgram)
			// console.log(this.orderByProgram, 'this.orderByProgram')
			this.fillingGrid(this.orderByProgram)
		},
		modelPrincipalProgram(program){
			const programPrincipal = {
				_id: program.refProgram._id,
				arrCheckCrosses: program.refProgram.arrCheckCrosses,
				checkedChanels: program.refProgram.checkedChanels,
				checkedSignals:program.refProgram.checkedSignals ,
				codProgram: program.refProgram.codProgram,
				codeDays: program.refProgram.codeDays,
				geminisCode: program.refProgram.geminisCode,
				programTitle: program.refProgram.programTitle,
				scheduleEndHour: program.scheduleEndHour,
				scheduleEndMin: program.scheduleEndMin,
				scheduleStartHour: program.scheduleStartHour,
				scheduleStartMin: program.scheduleStartMin,
				transmissionDays: program.refProgram.transmissionDays,
				classification: program.classification,
				isTemporada: program.isTemporada,
				isClasification: program.isClasification,
				clasificationColor: program.clasificationColor,
				seasonColor: program.seasonColor,
				isUnitPrice: program.isUnitPrice,
				unitPriceColor: program.unitPriceColor,
				generalNote: program.generalNote,
				IsCodProvider: program.IsCodProvider,
				providerCode: program.providerCode,
				transmissionDaysDescription: this.dayStartAndDayEnd(program.refProgram.transmissionDays),
				typeOfContent: program.typeOfContent,
				materialTitle: program.materialTitle,
				materialHasChapter: program.materialHasChapter,
				materialType: program.materialType,
				firstActor: program.firstActor,
				secondActor: program.secondActor,
				unitPrice: program.unitPrice,
				season: program.season,
				stringMaterialType: program.stringMaterialType,
				codeFeatureFilm: program.codeFeatureFilm,
				materialReferencia: program.materialReferencia,
        		material: program.material
			}
			return programPrincipal
		},
		convertToMinutes(hours, minutes){
			const result = (hours * 60) + minutes
			return result
		},
		sortByHour(programs) {
			return programs.slice().sort(function(a, b) {
				//SE ORDENA POR TOTAL DE MINUTOS
				const firstProgramMinutesTotal = (a.programPrincipal.scheduleStartHour * 60) + a.programPrincipal.scheduleStartMin
				const secondProgramMinutesTotal = (b.programPrincipal.scheduleStartHour * 60) + b.programPrincipal.scheduleStartMin
				
				return firstProgramMinutesTotal - secondProgramMinutesTotal;
			});
		},
		getDayCode (day){
			let daySelected = day.split(' ')[0]
			let dayCode = ''
			switch(daySelected){
				case 'Lunes':
					dayCode = 2
				break;
				case 'Martes':
					dayCode = 3
				break;
				case 'Miércoles':
					dayCode = 4
				break;
				case 'Jueves':
					dayCode = 5
				break;
				case 'Viernes':
					dayCode = 6
				break;
				case 'Sábado':
					dayCode = 7
				break;
				case 'Domingo':
					dayCode = 1
				break;
			}

			return dayCode
		},
		addingZerosToTheDay (day) {
			if(String(day).length < 2){
				day = '0'+ day
			}
			return day
		},
	  	fillingGrid (data) {
			let programs = data
			this.contentHtml = ''
			programs.map((program, index) => {
				let template = ''
				const nameProgram = program.programPrincipal.programTitle	
				const arrDays = program.programByDay.map((e)=> (this.getDayCode(e.completeDate) == 1)?8:this.getDayCode(e.completeDate))

				const daysInOrder = arrDays.sort()

				let hourStart = program.programPrincipal.scheduleStartHour
				let hourEnd = program.programPrincipal.scheduleEndHour
				let minEnd = program.programPrincipal.scheduleEndMin
				let minStart = program.programPrincipal.scheduleStartMin

				if (hourStart <5 ) {
				hourStart = Number(hourStart) + 24
				}
				else if (hourStart == 5 && hourEnd !== 5 && minStart != 16 && minEnd == 16 ) {
				hourStart = Number(hourEnd) + 24
				}
				
				if (hourEnd <5) {
				hourEnd = Number(hourEnd) + 24
				} 
				else if (hourEnd == 5 && minEnd<=16) {
				hourEnd = Number(hourEnd) + 24
				}
				
        		const totalMinutesStart = (Number(hourStart)*60) + Number(program.programPrincipal.scheduleStartMin)
				const totalMinutesEnd = (Number(hourEnd)*60) + Number(minEnd)
        
				let initGrid = Math.round(totalMinutesStart/5 - 63.2 )
				let finalGrid = Math.round(totalMinutesEnd/5 - 63.2 )

				let concatGrid = (initGrid+1) +' / '+ (daysInOrder[0]-1) + ' / span '+ (finalGrid - initGrid) + ' / ' + (daysInOrder[(daysInOrder.length)-1])

				template = `<div class="grid-programsByDay" style="grid-area: ${concatGrid};">
								${nameProgram}
							</div>`
				this.contentHtml += template

				let divObj = 'cell-'+index
				this.$refs[divObj] && this.$refs[divObj][0] ? this.$refs[divObj][0].style.gridArea = concatGrid : ''
			})
		},
		dayStartAndDayEnd(val) {
			if(val && val.length > 1) {
				const counter = val.length
				const connect = val[0] == 'Lunes' ? 'a' : 'y'
				const counterCondicional = connect == 'a' ? 5 : 2
				const text = `${val[0]} ${connect} ${val[counter-1]}`
				return {
					text,
					value: counterCondicional
				}
			} else if(val && val.length == 1) {
				return {
					text: val[0],
					value: 1
				}
			}
		},
		/*___________________Métodos para crear el array de las horas ____________________*/
		getTime(firstTime, secondTime, operator) {
			const secs1 = this.stringToSeconds(firstTime)
			const secs2 = this.stringToSeconds(secondTime)
			let secsDif
			if(operator == 'sum') {
				secsDif = secs1 + secs2
			} else {
				if(secs1 > secs2) {
					secsDif = secs1 - secs2
				} else {
					secsDif = secs2 - secs1
				}
			}
			return this.secondsToTime(secsDif)
    	},
		stringToSeconds(tiempo) {
			let sep1 = tiempo.indexOf(":")
			let sep2 = tiempo.lastIndexOf(":")
			let hor = tiempo.substr(0, sep1)
			let min = tiempo.substr(sep1 + 1, sep2 - sep1 - 1)
			return Number(min) * 60 + Number(hor) * 3600
		},
		secondsToTime(secs) {
			let hor = Math.floor(secs / 3600)
			let min = Math.floor((secs - hor * 3600) / 60)
			let sec = secs - hor * 3600 - min * 60
			// return this.padNmb(hor, 2) + ":" + this.padNmb(min, 2)
			return (
				this.padNmb(hor, 2) +
				":" +
				this.padNmb(min, 2) +
				":" +
				this.padNmb(sec, 2)
			)
		},
		padNmb(nStr, nLen) {
			const sRes = String(nStr)
			const sCeros = "0000000000"
			return sCeros.substr(0, nLen - sRes.length) + sRes
		},
		recordArray(firstTime, secondTime, operator, record) {
			const arr = [firstTime]
			for (let i = 0; i < record; i++) {
				arr.push(this.getTime(arr[i], secondTime, operator));
			}
			return arr
		},
		formatedArray() {
			const b = this.recordArray("05:30:00", "00:30:00", 'sum', 36).concat(this.recordArray("00:00:00", "00:30:00", 'sum', 9 ))
			// const c = b.unshift("05:16:00")
			const d = b.map((e) => e.slice(0, 5))
			return d
		},
		isHaveClassification(val) {
			let value
			if(val) {
				value = `(${val})`
			} else {
				value = ''
			}
			return value
		},
		noteDiv(classAsigned, nota) {
			const reviewClass = classAsigned.replace('el-textarea__inner', '') 
			const classSelect = reviewClass.replace('textarea-style', '')
			const template = nota && nota !== ''? `<div><p class="${classSelect}">${nota}</p></div>` : ''
			return template
		},
		isHaveActors(val) {
			let value, arr
			if(val && val.artisticInfo) {
				let exitsActors = val.artisticInfo.length > 0 ? val.artisticInfo[0].mainActors : []
				let counterActors = exitsActors.length
				if(counterActors > 2) {
					arr = [exitsActors[0], exitsActors[1]]
				} else {
					arr = exitsActors
				}
				value = arr
			}
			return value
		},
		calculateScheduleHours(scheduleStartHour, scheduleStartMin) {
			return calculateSchedule(scheduleStartHour, scheduleStartMin)
		},
		calculateTime(val) {
			const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin, programTitle} = val
			
			let timeStartProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleStartHour, scheduleStartMin), val.programDate, 'start' )
			let timeEndProgramCardsData = convertFormatDayForCrusses( convertHourDate(val.programDate, scheduleEndHour, scheduleEndMin), val.programDate, 'end' )
			
			let timeStart = new Date(String(timeStartProgramCardsData)).getTime()
			let timeEnd = new Date(String(timeEndProgramCardsData)).getTime()
			let hourDiff = timeEnd - timeStart
			let secDiff = hourDiff / 1000
			let minDiff = hourDiff / 60 / 1000
			let hDiff = hourDiff / 3600 / 1000
			let result = {}
			result.hours = Math.floor(hDiff)
			result.minutes = minDiff - 60 * result.hours
			
			let response =  `${this.calculateHour(String(result.hours))}:${this.calculateHour(String(result.minutes))}:00`
			return response
		},
		conditionalDate(val) {
			let getTime = val.split(":")
			let getHour = String(getTime[0])
			let hour = this.calculateHour(getHour)
			let getMin = String(getTime[1])
			let min = this.calculateHour(getMin)
			let conditionalHour = hour === '00' ? '24' : hour
			// let time = val == '00:00' ? '24:00:00' : `${hour}:${min}:00`
			let time = `${conditionalHour}:${min}:00`
			return time
		},
		calculateHour(hour) {
			return hour.length >= 2 ? hour : `0${hour}`
		},
		styleClasification(val) {
			let classToAdd = (val.material.canned == false)?'text-marron':'text-red'
			const data = this.calculateTime(val)
			if(data <= '00:30:00') {
				classToAdd = 'hidden'
			} else if(data > '00:30:00' && data <= '01:00:00') {
				classToAdd = classToAdd + ' font-size-9 d-inline-block m-top-15'
			} else {
				classToAdd = classToAdd + ' font-size-14'
			}
			return classToAdd
		},
		styleTitlePrincipal(program){
			const {programTitle} = program[0]
			const data = this.calculateTime(program[0])
			let conditional = program.length == 1 ? true : false
			let time
			let chapter = program.map((e) => {
				let counter = []
				e.chapters.forEach((e) => {
					if(e.priceByPass && e.priceByPass !== '') {
						counter.push(e.priceByPass)
					}
				})
				return counter
			})
			let chapterTransform = [].concat.apply([], chapter)
			if(conditional) {
				if(data <= '00:10:00') {
					return sizeLetttersAboutProgramCompare(programTitle,'letters-small font-weight-0 m-0 p-i-0 width_auto font-i-8', 'letters-small  font-weight-0 m-0 p-0 width_auto font-i-12', 14)
				} else {
					return this.sizeTitleOneDay(programTitle, data, 'p-i-0 width_auto m-i-0')
				}
			} else {
				return chapterTransform.length > 1  && data <= '00:40:00' ? this.sizeTitle(programTitle, data, 'm-i-0') : this.sizeTitle(programTitle, data,'m-i-0')
			}
		},
		sizeTitle(programTitle, data, style_extra) {
			let time
			if(data <= '00:05:00') {
				time = sizeLetttersAboutProgramCompare(programTitle,'letters-small font-weight-0 m-0 p-0 width_auto font-i-10', 'letters-small font-weight-0 m-0 p-0 width_auto font-i-12', 14)
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-weight-0 p-i-0 width_auto font-i-10', 'font-weight-0 m-0 font-i-14', 14)
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-weight-0 font-i-12', 'font-weight-0  m-0 font-i-16', 14)
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-weight-0 font-i-14', 'm-0 font-i-16', 14)
			} else if (data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'm-0 w-100 p-0 font-i-16', 'm-0 font-i-20')
			} else {
				time = sizeLetttersAboutProgram(programTitle, 'm-0 w-100 p-0 font-i-18', 'm-0 font-i-24')
			}
			return style_extra ? `${time} ${style_extra}` : time
		},
		sizeTitleOneDay(programTitle, data, style_extra) {
			let time
			if(data <= '00:05:00') {
				time = sizeLetttersAboutProgramCompare(programTitle,'letters-small font-weight-0 m-0 p-0 width_auto line_height_syle  font-i-10', 'letters-small font-weight-0 m-0 p-0 width_auto line_height_syle  font-i-12', 14)
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-weight-0 p-i-0 width_auto line_height_syle font-i-10', 'font-weight-0 m-0 line_height_syle font-size-12',14)
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-weight-0 line_height_syle font-i-10', 'font-weight-0 m-0 line_height_syle font-i-13', 24)
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgramCompare(programTitle, 'font-weight-0 font-i-13 ', 'm-0 font-i-15', 14)
			} else if (data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'm-0 w-100 p-0 font-i-15', 'm-0 font-i-17')
			} else {
				time = sizeLetttersAboutProgram(programTitle, 'm-0 w-100 p-0 font-i-17', 'm-0 font-i-19')
			}
			return `${time} ${style_extra}`
		},
		durationProgram(program) {
			let time
			let data = this.calculateTime(program.programByDay[0])
			const {programTitle, materialTitle} = program.programPrincipal
			let conditional = program.length == 1 ? true : false
			let chapter = program.programByDay.map((e) => {
				let counter = []
				e.chapters.forEach((e) => {
					if(e.priceByPass && e.priceByPass !== '') {
						counter.push(e.priceByPass)
					}
				})
				return counter
			})
			let chapterTransform = [].concat.apply([], chapter)

			if(data <= '00:05:00') {
				time = 'letters-small font-i-8 font-weight-0 m-0'
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-8 font-weight-0', 'font-i-11 font-weight-0 m-0')
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-9 font-weight-0', 'font-i-12 font-weight-0 m-0')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-12 font-weight-0', 'font-i-14 m-0')
			} else if(data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(materialTitle, 'font-i-14 font-weight-0', 'font-i-16 m-0')
			} else if(data > '01:30:00' && data <= '02:00:00') {
				time = sizeLetttersAboutProgramCompare(materialTitle, 'font-i-16 font-weight-0', 'font-i-18 m-0', 35)
			} else {
				time = 'font-i-20 m-0'
			}
			return time
		},
		durationProgramResize(program) {
			const {programTitle} = program[0]
			let time
			let data = this.calculateTime(program[0])
			let chapter = program.map((e) => {
				let counter = []
				e.chapters.forEach((e) => {
					if(e.priceByPass && e.priceByPass !== '') {
						counter.push(e.priceByPass)
					}
				})
				return counter
			})
			let chapterTransform = [].concat.apply([], chapter)
			let style
			if(data <= '00:05:00') {
				time = `programSmall`
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = `programMiddle`
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = `programRegular`
			}  else if(data > '00:30:00' && data <= '01:28:00') {
				time = `programBig`
			} else {
				time = `programLarge`
			}
			// if(chapterTransform.length > 1) {
			// 	style = time
			// } else {
			// 	style = `${time}  vertical_middle`
			// }
			
			return style
		},
		durationProgramTitleLargometraje(val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-8', 'font-i-10')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-i-10', 'font-i-11')
			} else {
				time = 'font-i-12'
			}
			return time
		},
		styleByDurationProgram(val) {
			const {programTitle} = val 
			const time = this.calculateTime(val)
			let style
			if (time <= '00:30:00') {
				style = 'program_small'
			} else if (time > '00:30:00' && time <= '00:45:00') {
				style = 'program_medium'
			} else if (time > '00:45:00' && time <= '01:15:00') {
				style = 'program_normal'
			} else if (time > '01:15:00' && time <= '01:45:00') {
				style = 'program_large'
			} else {
				style = 'program_xLarge'
			}
			return style
		},
		getResize(index, program) {
			// const {programTitle} = program.programByDay[0]
			// let time = this.calculateTime(program.programByDay[0])
			// let chapter = program.programByDay.map((e) => {
			// 	let counter = []
			// 	e.chapters.forEach((e) => {
			// 		if(e.priceByPass && e.priceByPass !== '') {
			// 			counter.push(e.priceByPass)
			// 		}
			// 	})
			// 	return counter
			// })
			// let chapterTransform = [].concat.apply([], chapter)
			// let nameClass = 'resize_box_print'
			// if(chapterTransform.length >= 1) {
			// 	// console.log(time, 'time')
			// 	// console.log(chapterTransform, 'chapterTransform')
			// 	if(time < '00:10:00') {
			// 		return 'resize_box_print class_bottom'
			// 	} else if (time >= '00:10:00' && time <= '00:15:00') {
			// 		console.log(programTitle, 'programTitle 22')
			// 		console.log(chapterTransform, 'chapterTransform 22')
			// 		return 'resize_box_print class_bottom_3'
					
			// 	} else if( time > '00:15:00' && time <= '00:20:00') {
			// 		return 'resize_box_print class_bottom_4'
			// 	} else if( time > '00:20:00' && time <= '00:35:00') {
			// 		return 'resize_box_print'
			// 	}
				
			// } else {
			// 	return 'grid-byProgram'
			// }
			return 'grid-byProgram'
		},
	},
	created () {
		this.getWeek(this.dateString)
		this.timeForDay = this.formatedArray()
	},
	destroyed () {
		window.removeEventListener('scroll', this.handleScroll);
	},
	watch: {
		orderByProgram(val) {
			if ( val !== [] ) {
				this.fillingGrid(this.orderByProgram)
			}
		}
	},
}
</script>
<style scoped>
.grid-schedule.resize{
	resize: vertical;
	overflow: auto;
}
.grid-schedule.resize.o-hidden{overflow: hidden;display:flex;justify-content: center}
.border-none{border:none}
.heigth-31 {
	height: 31px !important;
}
</style>